"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ngxFirebaseWebAuthnCreateReauthenticationChallenge = void 0;
const tslib_1 = require("tslib");
const server_1 = require("@simplewebauthn/server");
const auth_1 = require("firebase-admin/auth");
const firestore_1 = require("firebase-admin/firestore");
const firebase_functions_1 = require("firebase-functions");
exports.ngxFirebaseWebAuthnCreateReauthenticationChallenge = (0, firebase_functions_1.runWith)({
    enforceAppCheck: true,
})
    .https
    .onCall((createReauthenticationChallengeFunctionRequest, callableContext) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
    return callableContext.auth ? ((auth, firestore) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        return ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            return userDocument ? (() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                return userDocument.credentialId ? ((publicKeyCredentialRequestOptions) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                    return ((_writeResult) => ({
                        success: true,
                        requestOptions: publicKeyCredentialRequestOptions,
                    }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).set({
                        challenge: publicKeyCredentialRequestOptions.challenge,
                    }, {
                        merge: true,
                    }));
                }))((0, server_1.generateAuthenticationOptions)({
                    allowCredentials: [
                        {
                            id: userDocument.credentialId,
                            type: "public-key",
                        },
                    ],
                    rpID: callableContext.rawRequest.hostname,
                    userVerification: "required",
                })) : {
                    success: false,
                    message: "A passkey doesn't exist for this user.",
                };
            }))() : {
                success: false,
                message: "This user doesn't exist.",
            };
        }))((yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).get()).data());
    }))((0, auth_1.getAuth)(), (0, firestore_1.getFirestore)()) : {
        success: false,
        message: "Please sign in first.",
    };
}));
//# sourceMappingURL=create-reauthentication-challenge.function.js.map